* CAPTEXT.PRG , CAPTEXT.EXE and CAPTEXT.DOC were written by:
* Phil Barnett on 02/13/91
* and are hereby released into the PUBLIC DOMAIN

parameters source,target

set cursor (.f.)

source = upper(iif(type('SOURCE') = 'U','',source))
target = upper(iif(type('TARGET') = 'U','',target))

IF ISCOLOR()
  mcolor1 = "GR+/B,R/W,B,,W+/N"    
  mcolor2 = "W+/R,GR+/B,R,,W+/N"   
  mcolor3 = "W+/RB"                
  mcolor4 = "n/bg"                 
  mcolor5 = "W+/RB"                
  mcolor6 = "GR+/R"                
  mcolor7 = "BG+/B"                
  mcolor8 = "B/B,B/B"              
  mcolor9 = "R/R,R/R"              
  mcolor10 = "B/N"                 
  mcolor11 = "GR+/GR,BG+/B,,,W/N"  
  mcolor12 = "G+/GR,GR+/R,,,W/N"   
  mcolor13 = "N/BG"                
  mcolor14 = "GB+/BG"              
  mcolor15 = "G+/BG"               
  mcolor16 = "GR+*/R"              
  mcolor17 = "gr+/gb"              
  mcolor18 = "GR+*/GR"             
  mcolor19 = 'GR+*/GR'             && Active message Flashing
  monochrome = .f.
ELSE
  FOR I = 1 TO numofcols
    ii=Ltrim(Trim( STR(I,2) ))
    mcolor&ii = ""
  NEXT
  mcolor4 = 'n/w'                  && HELP Text
  mcolor5 = 'n/w'                  && Copyright Color
  mcolor6 = 'n/w'                  && Warning & message color for mcolor1
  mcolor19 = 'w*/n'
  monochrome = .t.
ENDIF
cls()
attention('Proper Case Converter for Text Files',2)
IF empty(source) .OR. empty(target)
  private msg[3]
  msg[1] = 'Proper usage is:'
  msg[2] = ''
  msg[3] = '>PROPCASE SOURCE TARGET'
  pop_msg(msg)
  set cursor (.t.)
  QUIT
ENDIF
IF UPPER(source) == UPPER(target)
  pop_msg('Source name and Target name must be different')
  set cursor (.t.)
  QUIT
ENDIF
makelow = verify('Force all input to lower case before processing?')
ifile = fopen(source)
IF ferror() != 0
  pop_msg('Unable to open input file.')
  set cursor (.t.)
  quit
ENDIF
if file(target)
  private msg[3]
  msg[1] = 'The output file '+target+' already exists.'
  msg[2] = ''
  msg[3] = 'Do you want to overwrite this file?'
  if !verify(msg)
    set cursor (.t.)
    quit
  endif
endif
ofile = fcreate(target)
IF ferror() != 0
  pop_msg('Unable to open output file.')
  set cursor (.t.)
  quit
ENDIF
attention(SOURCE+' ---> '+TARGET,12)
attention('Current Location',14)
propbuff = ''
totbytes = 0
size = 128
buffer = SPACE(size)
num_read = fread(ifile,@buffer,size)
totbytes = totbytes + num_read
cnt(str(totbytes,6),16)
DO WHILE num_read = size
  propbuff = propbuff + buffer
  lastspace = rat(' ',propbuff)
  tocap = LEFT(propbuff,lastspace-1)
  propbuff = SUBSTR(propbuff,lastspace)
  IF makelow
    tocap = LOWER(tocap)
  ENDIF
  tocap = proper(tocap)
  fwrite(ofile,tocap,len(tocap))
  num_read = fread(ifile,@buffer,size)
  totbytes = totbytes + num_read
  cnt(str(totbytes,6),16)
ENDDO
tocap = propbuff + left(buffer,num_read)
IF makelow
  tocap = LOWER(tocap)
ENDIF
tocap = proper(tocap)
fwrite(ofile,tocap,len(tocap))
fclose(ifile)
fclose(ofile)
set cursor (.t.)

****************************************************************************

FUNCTION PROPER

PARAMETER source_str

digits="0123456789"
inword="0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'"

sourclen = LEN(source_str)
thispos = 1
sepflag = .T.

DO WHILE thispos <= sourclen
   thischar=SUBSTR(source_str,thispos,1)
   IF thischar$inword .AND. sepflag
      sepflag = .F.
      source_str = IIF(thispos=1,'',LEFT(source_str,thispos-1))+;
         UPPER(thischar)+;
         SUBSTR(source_str,thispos+1)
   ELSE
      IF !thischar$inword
         sepflag = .T.
      ENDIF
   ENDIF
   thispos = thispos + 1
ENDDO

RETURN source_str
